#include "port.h"
#include "utility.h"
#include "fang.h"
#include "fa_internal.h"

/*LINTLIBRARY*/

void fa_andnot(geo1, geo2, outgeo)
fa_geometry *geo1, *geo2;
fa_geometry *outgeo;
{
    fa_geometry ngeo;
    fa_box bb;

    if (geo2->count == 0 || geo1->count == 0) {
	fa_copy(geo1, outgeo);
	return;
    }
	
    bb.left = MIN(geo1->bb.left, geo2->bb.left);
    bb.right = MAX(geo1->bb.right, geo2->bb.right);
    bb.bottom = MIN(geo1->bb.bottom, geo2->bb.bottom);
    bb.top = MAX(geo1->bb.top, geo2->bb.top);

    fa_invert(geo2, &bb, &ngeo);

    if (fa_debug) {
	(void) fprintf(stderr, "fa_andnot : after invert :\n");
	fa_dump_vertices(ngeo.head);
    }

    fa_init(outgeo);

    fa_and(&ngeo, geo1, outgeo);
    
    fa_free_geo(&ngeo);

    if (fa_debug) {
	(void) fprintf(stderr, "after and :\n");
	fa_dump_vertices(outgeo->head);
    }
}
