#include "port.h"
#include "utility.h"
#include "fang.h"
#include "scan.h"
#include "fa_internal.h"

/*LINTLIBRARY*/
static int put_box();


#include "boxer_procs.h"	/* contains boxer_scan and 
				   boxer_check_emit */

void fa_to_boxes(geo, outbox)
fa_geometry *geo;
fa_box **outbox;
{
    fa_vertex *vertex;
    scan_line line;
    scan_point *pointer;
    fa_coord current_y;
    int delta;

    fa_merge1(geo);

    fa_init_line(&line);
    *outbox = NIL(fa_box);

    vertex = geo->head;

    while ( vertex != NIL(fa_vertex) ) {
	
	current_y = vertex->y;
	pointer = line.head;

	while ( vertex != NIL(fa_vertex) && vertex->y == current_y) {
	    
	    delta = fa_vertex_delta( vertex->type );
	    pointer = boxer_scan(pointer, vertex->x);

	    if ( pointer->x == vertex->x ) {
		pointer->delta += delta;
	    } else {
		fa_insert_point(pointer, vertex->x, vertex->y, delta);
		pointer = pointer->next;
	    }

	    boxer_check_emit( outbox, pointer, vertex );

	    if (pointer->delta == 0) {
		pointer = pointer->last;
		fa_remove_point(pointer->next);
	    }

	    fa_next_vertex(&vertex);

	}

    }

    if ( line.head->next != line.tail ) {
	fa_error("Panic : Non-empty scan line at end of boxer");
    }

    fa_free_line(line);
}
