/*
 * equal.c
 *
 * Copyright -C- 1988	Brian D. N. Lee
 * University of California, Berkeley
 *
 * Comapare two fang geometries for equality.
 */

#include "copyright.h"
#include "port.h"
#include "fang.h"

int
fa_equal(geo1, geo2)
fa_geometry *geo1, *geo2;
{
    /* Returns
     *      1  if the two geometries have identical points
     *      0  otherwise
     */
    fa_vertex *vtx1, *vtx2;

    fa_merge1(geo1);
    fa_merge1(geo2);

    if ( fa_count(geo1) != fa_count(geo2) ) return 0;

    for ( vtx1 = geo1->head, vtx2 = geo2->head; vtx1 != 0;
	  vtx1 = vtx1->next, vtx2 = vtx2->next ) {
	if ( vtx1->x != vtx2->x || vtx1->y != vtx2->y ) return 0;
    }
    return 1;
}
