#include "port.h"
#include "utility.h"
#include "fang.h"
#include "fa_internal.h"

    /* get the next vertex from the vertex list, merging
       abutting vertices in either LEFT_DIAGONAL or RIGHT_DIAGONAL
     */
void fa_next_vertex(result)
fa_vertex **result;
{
    register fa_vertex *vertex, *next;
    static fa_vertex merged_vertex;
    int delta;

    if (*result == NIL(fa_vertex) ) {
	fa_error("Panic : Unexpected NIL vertex in next_vertex");
    }

    *result = vertex = (*result)->next;

    if (*result == NIL(fa_vertex) ) {
	return;
    }

    next = (*result)->next;

    if (next != NIL(fa_vertex)) {

	if (vertex->x == next->x && vertex->y == next->y) {

	    merged_vertex = *vertex;

	    delta = fa_vertex_delta(vertex->type) +
			fa_vertex_delta(next->type);

	    if (delta == 2) {
		merged_vertex.type = RIGHT_DIAGONAL;
	    } else if (delta == -2) {
		merged_vertex.type = LEFT_DIAGONAL;
	    } else {

		fa_error("Panic : Improper overlapping vertices, (x,y) = (%d,%d)",
			    vertex->x, vertex->y);
	    }

		/* eat both vertices and splice in the merged one */

	    merged_vertex.next = (*result)->next->next;
	    *result = &merged_vertex;

	    return;
	}
    }
}
