#include "port.h"
#include "utility.h"
#include "fang.h"
#include "fa_internal.h"

/* LINTLIBRARY */

#define TYPE		fa_vertex
#define NEXT		next
#define SORT		fa_list_sort
#include "lsort.h"

#define ARG_MIN(a,b,c) ((a) > (b) ? 1 : ((a) < (b) ? -1 : (c)))

int fa_compar_vertex(a, b)
fa_vertex *a, *b;
{
    return ARG_MIN(a->y, b->y, ARG_MIN(a->x, b->x, 0));
}


int fa_rev_compar_vertex(a, b)
fa_vertex *a, *b;
{
    return ARG_MIN(a->x, b->x, ARG_MIN(a->y, b->y, 0));
}


void fa_sort(geo)
fa_geometry *geo;
{
    register fa_vertex *p;
    
    if (! (geo->status & FA_SORTED) && (geo->count > 0)) {
	geo->head = fa_list_sort(geo->head, fa_compar_vertex, geo->count);
	for(p = geo->head; p != 0; p = p->next) {
	    geo->tail = p;
	}
	geo->status |= FA_SORTED;
    }
}


void fa_rev_sort(geo)
fa_geometry *geo;
{
    register fa_vertex *p;
    
    if (geo->count > 0) {
	geo->head = fa_list_sort(geo->head, fa_rev_compar_vertex, geo->count);
	for(p = geo->head; p != 0; p = p->next) {
	    geo->tail = p;
	}
    }
}
