/*
 * List package testing program
 *
 * David Harrison
 * University of California, Berkeley
 * 1988
 */

#include "copyright.h"
#include "port.h"
#include "list.h"
#include "errtrap.h"

/* for errtrap */
char *optProgName;

#define MAX_LINE	1024

/*ARGSUSED*/
main(argc, argv)
int argc;
char *argv[];
/*
 * Reads a list of names (and or) numbers into a list
 * sorts them and uniquifies them.  The resulting
 * list is output in reverse order.  This excercises
 * most of the package.
 */
{
    lsList list;
    lsGen gen;
    char line_buf[MAX_LINE];
    char *copy_line;

    optProgName = argv[0];
    list = lsCreate();
    while (fgets(line_buf, MAX_LINE, stdin) != (char *) 0) {
	copy_line = malloc((unsigned) ((sizeof(char) * strlen(line_buf)) + 1));
	if (copy_line == (char *) 0) {
	    errRaise(argv[0], 0, "out of memory");
	}
	(void) strcpy(copy_line, line_buf);
	lsNewEnd(list, (lsGeneric) copy_line, LS_NH);
    }
    lsSort(list, strcmp);
    lsUniq(list, strcmp, free);
    gen = lsEnd(list);
    while (lsPrev(gen, (lsGeneric *) &copy_line, LS_NH) == LS_OK) {
	(void) fputs(copy_line, stdout);
    }
    return 0;
}
