static char rcs_id[] = "$Id: edge.c,v 1.5 90/04/27 09:35:53 octtools Exp $";
/*
 * Implementations of the the oct functions for edgees.
 */

#include "copyright.h"
#include "port.h"
#include "internal.h"
#include "geo.h"
#include "io.h"


static octStatus edge_read_fields(), edge_write_fields(), edge_bb();

extern struct object_desc oct_geo_desc;
static struct object_desc *super = &oct_geo_desc;

oct_edge_desc_set(object_desc)
struct object_desc *object_desc;
{
    *object_desc = *super;
    
    object_desc->internal_size = sizeof(struct edge);
    object_desc->external_size = sizeof(struct octEdge);
    object_desc->flags |= HAS_BB_FUNC;
    object_desc->contain_mask = (octObjectMask) OCT_PROP_MASK|OCT_BAG_MASK;
    object_desc->user_offset = FIELD_OFFSET(struct edge, user_edge);
    object_desc->bb_func = edge_bb;
    object_desc->write_fields_func = edge_write_fields;
    object_desc->read_fields_func = edge_read_fields;
}
  

static octStatus
edge_bb(eptr, bbox)
generic *eptr;
struct octBox *bbox;
{
    struct edge *edge = (struct edge *) eptr;

    if (bbox == NIL(struct octBox)) {
	return OCT_OK;
    }
    
    bbox->lowerLeft.x = MIN(edge->user_edge.start.x,edge->user_edge.end.x);
    bbox->lowerLeft.y = MIN(edge->user_edge.start.y,edge->user_edge.end.y);
    bbox->upperRight.x = MAX(edge->user_edge.start.x,edge->user_edge.end.x);
    bbox->upperRight.y = MAX(edge->user_edge.start.y,edge->user_edge.end.y);
    return OCT_OK;
}

static int
edge_read_fields(eptr)
generic *eptr;
{
    struct edge *edge = (struct edge *) eptr;
    
    return (*super->read_fields_func)(eptr) &&
            oct_get_point(&edge->user_edge.start) &&
            oct_get_point(&edge->user_edge.end);
}

static int
edge_write_fields(eptr)
generic *eptr;
{
    struct edge *edge = (struct edge *) eptr;
    
    return (*super->write_fields_func)(eptr) &&
            oct_put_point(edge->user_edge.start) &&
	    oct_put_point(edge->user_edge.end);
}
