#ifndef OCT_FSYS_H
#define OCT_FSYS_H

#include "io_internal.h"

extern char *fsys_error_message;

#define FSYS_EXISTS	0x01
#define FSYS_CREATABLE	0x02
#define FSYS_LOCKED	0x04
#define FSYS_READABLE	0x10
#define FSYS_WRITABLE	0x20

#define FSYS_CHILD	0x01
#define FSYS_SIBLING	0x02

extern int fsys_commit();
extern int fsys_lock();
extern int fsys_unlock();
extern void fsys_print_key();
extern IOFILE *fsys_open();
extern void fsys_close();
extern int fsys_make_key();
extern int fsys_resolve();
extern int fsys_save_key();
extern char *fsys_full_name();
extern int fsys_free_key();
extern int fsys_compare_key();
extern int fsys_hash_key();

#endif /* OCT_FSYS_H */
