#ifndef OCT_IO_H
#define OCT_IO_H

/* 
 * Read a disk object id, translate it to an in-memory id.  If the 
 * corresponding object doesnt exist, create it.  return a ptr to
 * the object in either case
 */
#define GET_ID_AND_PTR(id, ptr, type) \
    if (!oct_get_32(&id)) {\
	return 0;\
    }\
    id += oct_id_offset;\
    ptr = oct_id_to_ptr(id);\
    if (ptr == NIL(generic)) {\
	ptr = (struct generic *) malloc((unsigned) oct_object_descs[type].internal_size);\
	ptr->contents = ptr->containers = NIL(struct chain);\
	CLEAR_FLAGS(ptr);\
	if (id != oct_new_id(ptr)) {\
	    oct_error("Panic: Corrupted facet: id's out of sequence");\
	    return 0;\
	}\
    }
/* 
 * lookup the disk id for `ptr', assigning it one if neccessary 
 */
#define PTR_TO_DUMP_ID(ptr, id)\
{\
   if (!oct_lookup_mark((generic *) ptr, &id)) {\
   	id = oct_next_dump_id++;\
	oct_mark_ptr((generic *) ptr, id);\
   }\
}


extern octId oct_id_offset, oct_next_dump_id;

#endif /* OCT_IO_H */

