#include "copyright.h"
#include "port.h"
#include "errtrap.h"
#include "oct.h"
#include "utility.h"
#include "oh.h"
#include "vov.h"


static void getProp( c, n, p, type )
    octObject *c;
    char *n;
    octObject *p;
    octPropType type;
{
    if ( ohGetByPropName( c, p, n ) != OCT_OK ) {
	errRaise( "OH", 1, "No prop %s in %s", n, ohFormatName( c ) );
    }
    if ( p->contents.prop.type != OCT_REAL ) {
	errRaise( "OH", 1, "Wrong type of %s",  ohFormatName( p ) );
    }
}



double ohGetRealProp( c, n )
    octObject *c;
    char *n;
{
    octObject p;
    
    getProp( c, n, &p, OCT_REAL );
    return p.contents.prop.value.real;
}

int ohGetIntegerProp( c, n )
    octObject *c;
    char *n;
{
    octObject p;
    getProp( c, n, &p, OCT_INTEGER );
    return p.contents.prop.value.integer;
}

char* ohGetStringProp( c, n )
    octObject *c;
    char *n;
{
    octObject p;
    getProp( c, n, &p, OCT_STRING );
    return p.contents.prop.value.string;
}

