#ifndef PEP_H
#define PEP_H

/* This structure contains a bounding-box description AND the list
 * of free sides. Sides are indicated by tap direction constants.
 * A side bit set means that that side is free. A bit reset means
 * that on that side there is something.
 */
typedef struct pepBox {
  octBox bb;
  unsigned int freeSides;
} pepBox;

/* This structure contains the data regarding a branch resistance: 
 * first node, second node, value and name */

typedef struct pepRes {
    char *name;
    double value;
    char *node1;
    char *node2;
} pepRes;

#define PEP_PKG_NAME "pep"

EXTERN octPoint pepCenterTerm
  ARGS( (octObject *term, double coord) );

EXTERN double pepCapacitance
  ARGS( (octObject *obj ));

EXTERN double pepCrossCapacitance
  ARGS( (octObject *obj1, octObject *obj2 ));

EXTERN double pepResistance
  ARGS( (octObject *source, octObject* target ));

EXTERN pepRes *pepBranchResistance
  ARGS( (octObject *net, int *numberOfBranches ));

EXTERN double pepPathRes
  ARGS( (octObject *path, octObject* t1, octObject* t2 ));

EXTERN double pepTermCap
  ARGS((octObject  *term));

#endif
