#include "port.h"
#include "copyright.h"
#include "utility.h"
#include "oct.h"
#include "region.h"
#include "oh.h"
#include "fang.h"
#include "harpoon.h"
#include "tap.h"
#include "th.h"
#include "pepint.h"


main(argc, argv)
int argc;
char **argv;
{

    char  name[128];
    pepRes *res; 
    int numberOfBranches; 
    octObject facet, net1;
    octGenerator netGen;
    int i;

    errProgramName(argv[0]);

    if((argc < 2) || (argc > 2)) {
	fprintf(stderr, "Usage:  %s  net1\n", argv[0]);
	exit(-1);
    }
    ohOpenFacet(&facet, "prova1", "CDabut.routed", "contents", "r");
    thTechnology(&facet);
    
    if (strcmp (argv[1], "all") == 0) {
	OH_ASSERT(octInitGenContents(&facet, OCT_NET_MASK, &netGen));
	while (octGenerate(&netGen, &net1) == OCT_OK) {
	    printf("NET----%s\n", net1.contents.net.name);
	    res = pepBranchResistance(&net1, &numberOfBranches);
	    for (i = 0; i < numberOfBranches; i++) {
		printf("resistance between point (%s) and point (%s) : ", 
		       res[i].node1, res[i].node2);
		printf("%s Ohm\n", util_pretty_print(res[i].value));
	    }
	}
	octFreeGenerator(&netGen);
    } else {
	OH_ASSERT(ohGetByNetName(&facet, &net1, argv[1]));
	res = pepBranchResistance( &net1, &numberOfBranches);
	for (i = 0; i < numberOfBranches; i++) {
	    printf("resistance between point (%s) and point (%s) : ", 
		   res[i].node1, res[i].node2);
	    printf("%s Ohm\n", util_pretty_print(res[i].value));
	}
    }
}

