/*
 * Joined Terminals
 *
 * David Harrison
 * University of California, Berkeley
 * 1990
 *
 * This file contains utility routines for dealing with joined
 * terminals.  Joined terminals are separate terminals that
 * are electrically equivalent.  The routines included here
 * test to see if a terminal is joined with others and
 * allow the user to find out what other terminals are
 * joined.
 */

#ifndef _JOINED_H_
#define _JOINED_H_

#include "ansi.h"
#include "oct.h"

extern int symNumJoined
  ARGS((octObject *term));
  /* Returns number of electrically equivalent terminals */

#define SYM_LIST_TOO_SMALL	-1

extern int symListJoined
  ARGS((octObject *term, int num, octObject joined[]));
  /* Fills in a list of electrically equivalent terminals */

#endif /* _JOINED_H_ */
