/*
 * Jump Terminal and Net Maintenence
 *
 * David Harrison
 * University of California, Berkeley
 * 1990
 *
 * This file contains definitions for functions that export
 * jump terminal and net policy.
 */

#ifndef _JUMP_H_
#define _JUMP_H_

#include "ansi.h"
#include "oct.h"

#define SYM_MAX_MSG	2048

typedef struct sym_jumpname_defn {
    void (*func)		/* Function to call */
      ARGS((octObject *term, char jump_name[SYM_MAX_MSG], char *data));
    char *data;			/* User data passed to function */
} symJumpNameFunc;

extern void symSetJumpNameFunc
  ARGS((symJumpNameFunc *new, symJumpNameFunc *old));
  /* Sets the global/local net naming function */

extern int symJumpTermP
  ARGS((octObject *obj));
  /* Returns non-zero value if given terminal is a jump terminal */

extern int symJumpTermDeepP
  ARGS((octObject *aterm));
  /* Examines interface master to determine jump term predicate */

extern int symJumpNetP
  ARGS((octObject *net));
  /* Returns non-zero status if net has any jump terminals on it */

extern void symAddToJTBag
  ARGS((octObject *term));
  /* Adds a terminal to the jump terminals bag for the facet */

extern void symCreateJumpNet
  ARGS((octObject *term, octObject *net));
  /* Creates a new jump terminal net */

#endif /* _JUMP_H_ */
