/*
 * Move Objects in Symbolic
 *
 * David Harrison
 * University of California,  Berkeley
 * 1987, 1989, 1990
 *
 * Move a set of objects without perturbing connectivity (drags
 * connection end-points).  This file contains exported functionality
 * from move.c.
 */

#ifndef _MOVE_H_
#define _MOVE_H_

#include "ansi.h"
#include "oct.h"

typedef struct sym_move_item_func_defn {
    void (*func)		/* Function to call */
      ARGS((octObject *item, int after_p, char *data));
    char *data;			/* Extra data       */
} symMoveItemFunc;

extern void symMoveObjects
  ARGS((octObject *set, struct octTransform *transform,
	symMoveItemFunc *move_func));
  /* Moves a set of objects without disturbing connectivity */

#endif /* _MOVE_H_ */
