/*
 * Terminal Information Header
 *
 * David Harrison
 * University of California,  Berkeley
 * 1987
 *
 * This file contains definitions for information returned
 * by the terminal information module.
 */

#ifndef _TERMINFO_H_
#define _TERMINFO_H_

#include "ansi.h"
#include "oct.h"

typedef struct term_dummy_defn {
    int dummy;
} term_dummy;

typedef term_dummy *symTermGen;


/* 
 * Information about segment terminals returned by seg_term()
 */

#define SEG_AT_CONNECTOR	1 /* Segment AT is a connector */
#define SEG_AT_MULTI		2 /* Segment AT is multi-layer */

typedef struct seg_term_info {
    short flags;		/* Terminal flags        */
    octObject term;		/* Terminal itself       */
    struct octBox term_bb;	/* Terminal bounding box */
} segTermInfo;

extern void symInitTerm
  ARGS((octObject *a_term, symTermGen *t_gen));
  /* Initializes generation of terminal implementations */

extern int symNextTerm
  ARGS((symTermGen gen, octObject *lyr, octObject *geo));
  /* Returns next implementation geometry in sequence */

extern void symEndTerm
  ARGS((symTermGen gen));
  /* Ends sequence of terminal generation */

extern void symSegTerms
  ARGS((octObject *segment, struct octPoint *points, segTermInfo info[2]));
  /* Produces information about segment endpoints */


#endif /* _TERMINFO_H_ */
