/*LINTLIBRARY*/
#include "copyright.h"
#include "port.h"
#include "utility.h"
#include "errtrap.h"
#include "oct.h"
#include "symlib.h"
#include "symlib_int.h"


void
symNameObject(object, name)
octObject *object;
char *name;
{
    octObject facet, obj;
    octStatus status;

    octGetFacet(object, &facet);

    obj.type = object->type;
    switch (object->type) {
	case OCT_TERM:
	if (!SYM_FTERMP(object)) {
	    errRaise(SYMLIB_PKG_NAME, SYM_ERROR, "can not name actual terminals");
	}
	object->contents.term.name = obj.contents.term.name = name;
	obj.contents.term.instanceId = oct_null_id;
	break;

	case OCT_NET:
	object->contents.net.name = obj.contents.net.name = name;
	break;

	case OCT_INSTANCE:
	object->contents.instance.name = obj.contents.instance.name = name;
	break;

	default:
	errRaise(SYMLIB_PKG_NAME, SYM_ERROR, "can only name nets, formal terminals, and instances");
    }
    
    if (name != NIL(char)) {
	status = octGetByName(&facet, &obj);
	switch (status) {
	    case OCT_OK:
	    errRaise(SYMLIB_PKG_NAME, SYM_ERROR, "object named %s already exists", name);

	    case OCT_NOT_FOUND:
	    break;

	    default:
	    RAISE_ERROR;
	}
    }
    OCT_CHECK(octModify(object));
    return;
}
